#import <OpenGL/gl.h>
#import <OpenGL/OpenGL.h>

#import "GLPointPatch.h"


@implementation GLPointPatch : QCPatch

+ (int)executionMode
{
	return 1;
}
+ (BOOL)allowsSubpatches
{
	return NO;
}
+ (int)timeMode
{
	return 1;
}


- (id)initWithIdentifier:(id)fp8
{
	id z=[super initWithIdentifier:fp8];
	if(z)
	{
		[inputSize setDoubleValue:8.0];
		[inputColor setRed:0.7 green:0.4 blue:0.4 alpha:0.9];
		
		[inputDepth setIndexValue:1];	// set normal read/write depth testing
	}
	return z;
}
- (id)attributes
{
	NSMutableDictionary *at=[[super attributes] mutableCopy];
	[at setObject:@"Kineme GL Point" forKey:@"name"];
	return at;
}


- (id)setup:(QCOpenGLContext *)context
{
	return context;
}
- (void)cleanup:(QCOpenGLContext *)context
{
}


- (void)enable:(QCOpenGLContext *)context
{
}
- (void)disable:(QCOpenGLContext *)context
{
}


- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments
{
	float red,green,blue,alpha;
	
	[inputColor getRed:&red green:&green blue:&blue alpha:&alpha];
	
	CGLSetCurrentContext([context CGLContextObj]);
	
	[inputBlending set:[context CGLContextObj]];
	[inputDepth set:[context CGLContextObj]];
	
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
	glEnable(GL_POINT_SMOOTH);
	glHint(GL_POINT_SMOOTH_HINT,GL_NICEST);
	
	glPointSize([inputSize doubleValue]);
	
	glBegin(GL_POINTS);
		glColor4f(red,green,blue,alpha);
		glVertex3f([inputX doubleValue],[inputY doubleValue],[inputZ doubleValue]);
	glEnd();

	[inputDepth unset:[context CGLContextObj]];
	[inputBlending unset:[context CGLContextObj]];

	return YES;
}

@end
